﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Threading.Tasks.Dataflow;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            #region Demo 1

            var subscriber = new ActionBlock<string>(input =>
                {
                    Console.WriteLine("Got: {0}", input);
                });


            for (int i = 0; i < 10; i++)
            {
                Task.Factory.StartNew(() =>
                    {
                        Thread.Sleep(new Random().Next(200, 1000));
                        subscriber.Post(DateTime.Now.ToLongTimeString());
                    });
            }

            #endregion
            #region Demo 2
            //var publisher = new Publisher();

            //var subscriber = new ActionBlock<string>(input =>
            //    {
            //        Console.WriteLine("Got: {0}", input);
            //    });

            //publisher.Subscribe(subscriber.AsObserver());

            //for (int i = 0; i < 10; i++)
            //{
            //    Task.Factory.StartNew(() =>
            //        {
            //            Thread.Sleep(new Random().Next(200, 1000));
            //            publisher.Send();
            //        });
            //}
            #endregion
            #region Demo 3
            //var subscriber = new ActionBlock<string>(input =>
            //{
            //    Console.WriteLine("Got: {0}", input);
            //});


            //Task.Factory.StartNew(() =>
            //{
            //    while (true)
            //    {

            //        Thread.Sleep(new Random().Next(200, 1000));
            //        subscriber.Post(DateTime.Now.ToLongTimeString());
            //    }
            //});

            //Console.WriteLine("Press any key to stop input");
            //Console.ReadLine();
            //subscriber.Complete();
            #endregion            
        }
    }

    public class Publisher : IObservable<string>
    {
        List<IObserver<string>> subscribers = new List<IObserver<string>>();

        public IDisposable Subscribe(IObserver<string> observer)
        {
            subscribers.Add(observer);
            return null;
        }

        public void Send()
        {
            foreach (var item in subscribers)
            {
                item.OnNext(DateTime.Now.ToLongTimeString());
            }
        }
    }

}
